from Tkinter import *
from tkMessageBox import *
import string
from HelpMenu import HelpMenuInd
class Pydat2(Frame):
    def __init__(self,master,pydat2):
        Frame.__init__(self,master)
        self.pack()
        master.focus_set()
#        master.grab_set()
        self.master.protocol('WM_DELETE_WINDOW', self.OK)
##################################
# Setup help menus
        top = HelpMenuInd(self.master,"#46d900",'pydat2','pydat2.txt')
        self.master.config(menu=top)
##################################
        options = ()
        self.config(bg="#46d900")
        self.pydat2 = pydat2
        self.pykey = IntVar()
        self.pykey.set(1)
        Label(self,text='set PYDAT2 pmas',bg="#46d900",font="Helvetica 16 bold").grid(row=0,column=0,columnspan=6)
        Label(self,text='particle KC code',bg="#46d900").grid(row=1,column=0)
        self.ent1 = Entry(self)
        self.ent1.grid(row=1,column=1)
        OptionMenu(self,self.pykey,1,2,3,4).grid(row=1,column=2)
        self.ent2 = Entry(self)
        self.ent2.grid(row=1,column=3)
        Button(self,text='Add',command=self.Add,width=12).grid(row=2,column=0)
        Button(self,text='Remove',command=self.Remove,width=12).grid(row=2,column=1)
        Button(self,text='View',command=self.View,width=12).grid(row=2,column=2)
        Button(self,text='OK',command=self.OK,width=5).grid(row=2,column=3)
        self.wait_window()
    def Add(self):
        try:
            ent1 = int(self.ent1.get())
        except ValueError:
            showerror('Error','You must enter a integer number')
            return
        try:
            ent2 = float(self.ent2.get())
        except ValueError:
            showerror('Error','You must enter a number')
            return
        if ent1 not in self.pydat2['pmas'].keys():
            self.pydat2['pmas'][ent1] = {}     
        self.pydat2['pmas'][ent1][self.pykey.get()] = ent2           
    def Remove(self):
        try:
            ent1 = int(self.ent1.get())
        except ValueError:
            showerror('Error','You must enter a integer number')
            return
        if ent1 in self.pydat2['pmas'].keys():
            if self.pykey.get() in self.pydat2['pmas'][ent1].keys():
                del(self.pydat2['pmas'][ent1])
            else:
                showinfo('pydat2 Remove','A value for this pydat2 pmas has not been set')
        else:
            showinfo('pydat2 Remove','A value for this pydat2 pmas has not been set')
    def View(self):
        text = Text(Toplevel(),relief=SUNKEN)
        text.pack()
        stuff = ''
        for a in self.pydat2.keys():
            for b in self.pydat2[a].keys():
                for c in self.pydat2[a][b].keys():
                    stuff += 'PYDAT2'+' '+a+' '+`b`+' '+`c`+' '+`self.pydat2[a][b][c]`+'\n'
        text.insert('1.0',stuff)
    def OK(self):
        if self.ent1.get():
            if int(self.ent1.get()) not in  self.pydat2['pmas'].keys():
                if not askyesno('Warning','You have unsaved data in the input fields. Exit anyway?'):
                    return
            elif int(self.pykey.get()) not in  self.pydat2['pmas'][int(self.ent1.get())].keys():
                if not askyesno('Warning','You have unsaved data in the input fields. Exit anyway?'):
                    return
            elif self.pydat2['pmas'][int(self.ent1.get())][self.pykey.get()] != float(self.ent2.get()):
                if not askyesno('Warning','You have unsaved changes in the input fields. Exit anyway?'):
                    return
        self.master.destroy()    

if __name__ == '__main__':
    root = Tk()
    pydat2 = {}
    pydat2['pmas'] = {}
    Pydat2(root,pydat2)
    root.mainloop()
