from Tkinter import *
from tkMessageBox import showerror,showinfo
import string
from HelpMenu import HelpMenuInd
#############################################################
# SET MDME 1
#############################################################
class Pydat3Mdme(Frame):
    def __init__(self,master,partDec,pydat,name,id):
        Frame.__init__(self,master)
        self.config(bg="#46d900")
        self.master = master
        self.master.protocol('WM_DELETE_WINDOW', self.OK)
##################################
# Setup help menus
        top = HelpMenuInd(self.master,"#46d900",'pydat3','pydat3.txt')
        self.master.config(menu=top)
##################################
        self.pack()
        self.mdme = pydat['mdme']
        self.name = name
        self.partDec = partDec
        self.brat = pydat['brat']
        self.pydat = pydat
        i = 1
        self.maxrow = 28
        self.id = id
        self.decChan = {}
        col = 0
        colspan = 2
        self.mdcy = IntVar()
        if self.id in self.pydat['mdcy'][1].keys():
            self.mdcy.set(self.pydat['mdcy'][1][self.id])
        else:
            self.mdcy.set(3)
        
        for a in partDec.keys():
            self.decChan[a] = IntVar()
            if a in pydat['mdme'][1].keys():
                self.decChan[a].set(pydat['mdme'][1][a])
            else:
                self.decChan[a].set(0)
            theText = `a`+': '+ partDec[a]
            Label(self,text=theText,bg="#46d900").grid(row=i,column=col,sticky=NSEW)
            fram = Frame(self,bg="#46d900")
            fram.grid(row=i,column=col+1,sticky=NSEW)
            for j in range(-1,6): 
                Radiobutton(fram,variable=self.decChan[a],value=j,text=j,bg="#46d900",highlightthickness="0" ,activebackground='red').grid(row=0,column=j+1,sticky=NSEW)
            i += 1
            if i==self.maxrow:
                col+=2
                colspan += 2
                i = 2

        mdcyFram = Frame(self,bg="#46d900")
        mdcyFram.grid(row=0,column=0,sticky=NSEW,columnspan=colspan)
        Label(mdcyFram,text='Allow '+name+' to decay?',bg="#46d900",fg="#0000c8").pack(side=LEFT)
        Radiobutton(mdcyFram,variable=self.mdcy,value=1,text='yes',bg="#46d900",highlightthickness="0" ,activebackground='red').pack(side=LEFT)
        Radiobutton(mdcyFram,variable=self.mdcy,value=0,text='no',bg="#46d900",highlightthickness="0" ,activebackground='red').pack(side=LEFT)
        Radiobutton(mdcyFram,variable=self.mdcy,value=2,text='reset',bg="#46d900",highlightthickness="0" ,activebackground='red').pack(side=LEFT)
        
        lab2 = Label(self,text='Choose Decay Channels (mdme 1) for '+name,bg="#46d900",fg="#0000c8")
        lab2.grid(row=1,column=0,columnspan=colspan,sticky=NSEW)
        butfram = Frame(self,bg="#46d900")
        self.but1 = Button(butfram,text='Set mdme2',command=self.setMdme2,width=10)
        self.but1.pack(side=LEFT)
        self.but2 = Button(butfram,text='Set brat',command=self.setBrat,width=10)
        self.but2.pack(side=LEFT)
        self.but3 = Button(butfram,text='OK',command=self.OK,width=10)
        self.but3.pack(side=RIGHT)
        if colspan != 2:
            i = self.maxrow
        butfram.grid(row=i,column=0,columnspan=colspan,sticky=NSEW)
        master.focus_set()
        #self.master.grab_set()
        self.wait_window()
    def OK(self):
        if self.mdcy.get() < 2:
            self.pydat['mdcy'][1][self.id] = self.mdcy.get()
        elif self.mdcy.get() == 2:
            if self.id in self.pydat['mdcy'][1].keys():
                del(self.pydat['mdcy'][1][self.id])
            
        for j in self.decChan.keys():
            self.mdme[1][j] = self.decChan[j].get()
        channelOn = 0
        for i in self.decChan.keys():
            if self.decChan[i].get() != 0:
                channelOn = 1
                break
        if channelOn:    
            for j in self.decChan.keys():
                    if self.mdme[1][j] == 0:
                        if j in self.mdme[2].keys():
                            del(self.mdme[2][j])
                        self.brat[j] = 0    
        else:
            for j in self.decChan.keys():
                del(self.mdme[1][j])
                if j in self.mdme[2].keys():
                    del(self.mdme[2][j])
                if j in self.brat.keys():
                    del(self.brat[j])
        bratOn = 0
        for i in self.decChan.keys():
            if i in self.brat.keys():
                if self.brat[i] !=0:
                    bratOn = 1
                    break
        if not bratOn:
            for i in self.decChan.keys():
                if i in self.brat.keys():
                    del(self.brat[i])
        self.master.destroy()
    def setMdme2(self):
        tempChan = {}
        for j in self.decChan.keys():
            tempChan[j] = self.decChan[j].get()
        self.disableEnable(DISABLED)
        Pydat3Mdme2(Toplevel(),self.partDec,self.mdme[2],tempChan,self.name)
        self.disableEnable(NORMAL)
    def setBrat(self):
        tempChan = {}
        for j in self.decChan.keys():
            tempChan[j] = self.decChan[j].get()
        self.disableEnable(DISABLED)
        Pydat3Brat(Toplevel(),self.partDec,self.brat,tempChan,self.name)      
        self.disableEnable(NORMAL)  
    def disableEnable(self,STATE):
        self.but1.config(state=STATE)
        self.but2.config(state=STATE)
        self.but3.config(state=STATE)
        
########################################################################
# SET MDME 2
########################################################################
class Pydat3Mdme2(Frame):
    def __init__(self,master,partDec,mdme2,tempChan,name):
        Frame.__init__(self,master)
##################################
# Setup help menus
        top = HelpMenuInd(self.master,"#46d900",'pydat3','pydat3.txt')
        self.master.config(menu=top)
##################################
        self.pack()
        self.config(bg="#46d900")
        self.master = master
        self.master.protocol('WM_DELETE_WINDOW', self.OK)
        self.mdme2 = mdme2
        self.tempChan = tempChan
        i = 1
        self.maxrow = 28
        col = 0
        colspan = 2
        self.ent = {}
        for a in partDec.keys():
            if tempChan[a] != 0:
                theText = `a`+': '+ partDec[a]
                Label(self,text=theText,bg="#46d900").grid(row=i,column=col,sticky=NSEW)
                self.ent[a] = Entry(self)
                self.ent[a].grid(row=i,column=col+1,sticky=NSEW)
                if a in self.mdme2.keys():
                    self.ent[a].insert(0,`self.mdme2[a]`)
                else:
                    self.ent[a].insert(0,'0')
                i += 1
            if i==self.maxrow:
                col+=2
                colspan += 2
                i = 1
            lab = Label(self,text='Set Mdme2 for '+name,bg="#46d900",fg="#0000c8")
            lab.grid(row=0,column=0,columnspan=colspan,sticky=NSEW)
            if colspan != 2:
                i = self.maxrow
            Button(self,text='OK',command=self.OK,width=20).grid(row=i,column=0,columnspan=colspan,sticky=NSEW)


        master.focus_set()
        self.master.grab_set()
        self.wait_window()
    def OK(self):
        for a in self.tempChan.keys():
            if self.tempChan[a] != 0:
                try:
                    ent = float(self.ent[a].get())
                except ValueError:
                    showerror('Error','You entered an invalid value. Invalid field ignored')
                    ent = 0
                if ent != 0:
                    self.mdme2[a] = ent
        self.master.destroy()
########################################################################
# SET BRAT
########################################################################
class Pydat3Brat(Frame):
    def __init__(self,master,partDec,brat,tempChan,name):
        Frame.__init__(self,master)
##################################
# Setup help menus
        top = HelpMenuInd(self.master,"#46d900",'pydat3','pydat3.txt')
        self.master.config(menu=top)
##################################
        self.pack()
        self.config(bg="#46d900")
        self.master = master
        self.master.protocol('WM_DELETE_WINDOW', self.OK)
        self.brat = brat
        self.tempChan = tempChan
        i = 1
        self.maxrow = 28
        col = 0
        colspan = 2
        self.ent = {}
        for a in partDec.keys():
            if tempChan[a] != 0:
                theText = `a`+': '+ partDec[a]
                Label(self,text=theText,bg="#46d900").grid(row=i,column=col,sticky=NSEW)
                self.ent[a] = Entry(self)
                self.ent[a].grid(row=i,column=col+1,sticky=NSEW)
                if a in self.brat.keys():
                    self.ent[a].insert(0,`self.brat[a]`)
                else:
                    self.ent[a].insert(0,'0')
                i += 1
            if i==self.maxrow:
                col+=2
                colspan += 2
                i = 1
        lab = Label(self,text='Set brat for '+name,bg="#46d900",fg="#0000c8")
        lab.grid(row=0,column=0,columnspan=colspan,sticky=NSEW)
        if colspan != 2:
            i = self.maxrow
        Button(self,text='OK',command=self.OK,width=20).grid(row=i,column=0,columnspan=colspan,sticky=NSEW)          


        master.focus_set()
        self.master.grab_set()
        self.wait_window()
    def OK(self):
        for a in self.tempChan.keys():
            if self.tempChan[a] != 0:
                try:
                    ent = string.atoi(self.ent[a].get())
                except ValueError:
                    showerror('Error','You entered an invalid value. Invalid field ignored!')
                    ent = 0
                if ent != 0:
                    self.brat[a] = ent
            else:
                self.brat[a] = 0
        self.master.destroy()
########################################################################
# SET MDCY
########################################################################
#class Pydat3Mdcy(Frame):
#    def __init__(self,master,mdcy,name,id):
#        Frame.__init__(self,master)
#        self.pack()
#        self.config(bg="#46d900")
#        self.master = master
#        self.mdcy = mdcy
#        self.id = id
#        Label(self,text='Set Mdcy 1, 2 & 3 for '+name,bg="#46d900",fg="#0000c8").grid(row=0,column=0,columnspan=2,sticky=NSEW)
#        Label(self,text='Mdcy 1',bg="#46d900",fg="#0000c8").grid(row=1,column=0,sticky=NSEW)
#        self.ent1 = Entry(self)
#        self.ent1.grid(row=1,column=1,sticky=NSEW)
#        if self.id in self.mdcy[1].keys():
#            self.ent1.insert(0,`self.mdcy[1][self.id]`)
#        Label(self,text='Mdcy 2',bg="#46d900",fg="#0000c8").grid(row=2,column=0,sticky=NSEW)
#        self.ent2 = Entry(self)
#        self.ent2.grid(row=2,column=1,sticky=NSEW)
#        if self.id in self.mdcy[2].keys():
#            self.ent2.insert(0,`self.mdcy[2][self.id]`)
#        Label(self,text='Mdcy 3',bg="#46d900",fg="#0000c8").grid(row=3,column=0,sticky=NSEW)
#        self.ent3 = Entry(self)
#        if self.id in self.mdcy[3].keys():
#            self.ent3.insert(0,`self.mdcy[3][self.id]`)
#        self.ent3.grid(row=3,column=1,sticky=NSEW)
#   
#        Button(self,text='OK',command=self.OK,width=20).grid(row=4,column=0,columnspan=2,sticky=NSEW)##
#
#        master.focus_set()
#        self.master.grab_set()
#        self.wait_window()
#    def OK(self):
#        if self.ent1.get():
#            try:
#                ent = int(self.ent1.get())
#            except ValueError:
#                showerror('Error','You entered an invalid value. Invalid field ignored!')
#                ent = 0
#            self.mdcy[1][self.id] = ent
#        else:
#            if self.id in self.mdcy[1].keys():
#                del(self.mdcy[1][self.id])
#        if self.ent2.get():
#            try:
#                ent = int(self.ent2.get())
#            except ValueError:
#                showerror('Error','You entered an invalid value. Invalid field ignored!')
#                ent = 0
#            self.mdcy[2][self.id] = ent
#        else:
#            if self.id in self.mdcy[2].keys():
#                del(self.mdcy[2][self.id])
#
#        if self.ent3.get():
#            try:
#                ent = int(self.ent3.get())
#            except ValueError:
#                showerror('Error','You entered an invalid value. Invalid field ignored!')
#                ent = 0
#            self.mdcy[3][self.id] = ent
#        else:
#            if self.id in self.mdcy[3].keys():
#                del(self.mdcy[3][self.id])
#
#        self.master.destroy()

