from Tkinter import *
from tkMessageBox import *
import string
from HelpMenu import HelpMenuInd
class Pypars(Frame):
    def __init__(self,master,pypars):
        Frame.__init__(self,master)
        self.pack()
        master.focus_set()
#        master.grab_set()
        self.master.protocol('WM_DELETE_WINDOW', self.OK)
##################################
# Setup help menus
        top = HelpMenuInd(self.master,"#46d900",'pypars','pypars.txt')
        self.master.config(menu=top)
##################################
        options = ()
        self.config(bg="#46d900")
        self.pypars = pypars
        self.pykey = StringVar()
        self.pykey.set('mstp')
        Label(self,text='set PYPARS',bg="#46d900",font="Helvetica 16 bold").grid(row=0,column=0,columnspan=6)
        OptionMenu(self,self.pykey,'mstp','parp','msti','pari').grid(row=1,column=0)
        self.ent1 = Entry(self)
        self.ent1.grid(row=1,column=1)
        self.ent2 = Entry(self)
        self.ent2.grid(row=1,column=2)
        Button(self,text='Add',command=self.Add,width=12).grid(row=2,column=0)
        Button(self,text='Remove',command=self.Remove,width=12).grid(row=2,column=1)
        Button(self,text='View',command=self.View,width=12).grid(row=2,column=2)
        Button(self,text='OK',command=self.OK,width=5).grid(row=2,column=3)
        self.wait_window()
    def Add(self):
        try:
            ent1 = string.atoi(self.ent1.get())
        except ValueError:
            showerror('Error','You must enter a integer number')
            return
        try:
            ent2 = string.atoi(self.ent2.get())
        except ValueError:
            showerror('Error','You must enter a number')
            return
        self.pypars[self.pykey.get()][ent1] = ent2            
    def Remove(self):
        try:
            ent1 = string.atoi(self.ent1.get())
        except ValueError:
            showerror('Error','You must enter a integer number')
            return
        if ent1 in self.pypars[self.pykey.get()].keys():
            del(self.pypars[self.pykey.get()][ent1])
        else:
                showinfo('pypars Remove','A value for this pypars has not been set')
    def View(self):
        if not self.pypars['mstp'] and not self.pypars['parp'] and not self.pypars['msti'] and not self.pypars['pari'] :
            showinfo('pypars View','No PYPARS values have been set')
            return
        text = Text(Toplevel(),relief=SUNKEN)
        text.pack()
        stuff = ''
        for a in self.pypars.keys():
            for b in self.pypars[a].keys():
                stuff += 'PYPARS'+' '+a+' '+`b`+' '+`self.pypars[a][b]`+'\n'
        text.insert('1.0',stuff)
    def OK(self):
        if self.ent1.get():
            if int(self.ent1.get()) not in  self.pypars[self.pykey.get()].keys():
                if not askyesno('Warning','You have unsaved data in the input fields. Exit anyway?'):
                    return
            elif self.pypars[self.pykey.get()][int(self.ent1.get())] != int(self.ent2.get()):
                if not askyesno('Warning','You have unsaved changes in the input fields. Exit anyway?'):
                    return
        self.master.destroy()    

        self.master.destroy()        
if __name__ == '__main__':
    root = Tk()
    pypars = {}
    pypars['mstp'] = {}
    pypars['parp'] = {}
    pypars['msti'] = {}
    pypars['pari'] = {}
    Pypars(root,pypars)
    root.mainloop()
