from Tkinter import *
from tkMessageBox import *
import string
from HelpMenu import HelpMenuInd
class PysubsCkin(Frame):
    def __init__(self,master,ckin):
        Frame.__init__(self,master)
        self.pack()
        self.master.protocol('WM_DELETE_WINDOW', self.OK)
        master.focus_set()
#        master.grab_set()
##################################
# Setup help menus
        top = HelpMenuInd(self.master,"#46d900",'ckin','pysubs_ckin.txt')
        self.master.config(menu=top)
##################################
        self.config(bg="#46d900")
        self.ckin = ckin
        Label(self,text='set PYSUBS/CKIN',bg="#46d900",font="Helvetica 16 bold").grid(row=0,column=0,columnspan=4)
        Label(self,text='CKIN',bg="#46d900").grid(row=1,column=0)
        self.ent1 = Entry(self)
        self.ent1.grid(row=1,column=1)
        Label(self,text='Value',bg="#46d900").grid(row=1,column=2)
        self.ent2 = Entry(self)
        self.ent2.grid(row=1,column=3)

        Button(self,text='Add',command=self.Add,width=12).grid(row=2,column=0)
        Button(self,text='Remove',command=self.Remove,width=12).grid(row=2,column=1)
        Button(self,text='View',command=self.View,width=12).grid(row=2,column=2)
        Button(self,text='OK',command=self.OK,width=5).grid(row=2,column=3)
        self.wait_window()
    def Add(self):
        try:
            ent1 = int(self.ent1.get())
        except ValueError:
            showerror('Error','You must enter an integer number for CKIN')
            return
        try:
            ent2 = float(self.ent2.get())
        except ValueError:
            showerror('Error','You must enter a number for CKIN value')
            return
        self.ckin[ent1] = ent2
#        print self.ckin
    def Remove(self):
        try:
            ent1 = int(self.ent1.get())
        except ValueError:
            showerror('Error','You must enter a integer number as CKIN')
            return
        try:
            ent2 = float(self.ent2.get())
        except ValueError:
            ent2 = 0
        if ent1 in self.ckin.keys():
            if not self.ckin[ent1] == ent2:
                showinfo('Ckin Remove','This CKIN was not set to this value. It will still been deleted!')
            del(self.ckin[ent1])                
        else:
                showinfo('Kfin Remove','This CKIN has not been set')
#        print self.ckin
    def View(self):
        if not self.ckin: 
            showinfo('Ckin View','No CKIN values have been set')
            return
        text = Text(Toplevel(),relief=SUNKEN)
        text.pack()
        stuff = ''
        for a in self.ckin.keys():
            stuff += 'PYSUBS CKIN '+`a`+' '+`self.ckin[a]`+'\n'
        text.insert('1.0',stuff)
    def OK(self):
        if self.ent1.get():
            if int(self.ent1.get()) not in  self.ckin.keys():
                if not askyesno('Warning','You have unsaved data in the input fields. Exit anyway?'):
                    return
            elif self.ckin[int(self.ent1.get())] !=  float(self.ent2.get()):
                if not askyesno('Warning','You have unsaved changes in the input fields. Exit anyway?'):
                    return
        self.master.destroy()        
if __name__ == '__main__':
    root = Tk()
    ckin = {}
#    kfin[1] = {}
#    kfin[2] = {}
    PysubsCkin(root,ckin)
    root.mainloop()
