from Tkinter import *
from pythiaallpurposecanvas import *
from pysubs_msub_nonsm import PysubsMsubNonSM
from tkMessageBox import showinfo
from HelpMenu import HelpMenuInd
class PysubsMsub(Frame):
    def __init__(self,master,msubs):
        Frame.__init__(self,master)
        master.focus_set()
        self.master=master
        self.master.title('pysubs msub') 
##################################
# Setup help menus
        self.top = HelpMenuInd(self.master,"#46d900",'msub','pysubs_msub.txt')
        self.master.config(menu=self.top)
##################################

        self.pack()
        self.theBackGround = '#46d900'
        self.config(bg=self.theBackGround)
    #the variables
        self.msubs = msubs
        self.subprocess = {}
        for id in self.msubs.keys():
            self.subprocess[id] = IntVar()
            self.subprocess[id].set(self.msubs[id])
        self.makeInterior()
    def makeInterior(self):
        Label(self,text='Physics Subprocesses (psubs msub) Standard Model',bg=self.theBackGround,fg='blue').grid(row=0,column=0,columnspan=3,sticky=NSEW)

        frame11 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame11.grid(row=1,column=0,sticky=NSEW)

        frame12 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame12.grid(row=1,column=1,sticky=NSEW)

        frame13 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame13.grid(row=1,column=2,sticky=NSEW)

        frame21 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame21.grid(row=2,column=0,sticky=NSEW)

        frame22 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame22.grid(row=2,column=1,sticky=NSEW)

        frame23 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame23.grid(row=2,column=2,sticky=NSEW)

        frame31 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame31.grid(row=3,column=0,sticky=NSEW)

        frame32 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame32.grid(row=3,column=1,sticky=NSEW)

        frame33 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame33.grid(row=3,column=2,sticky=NSEW)
        #HARD QCD
        TitleProCan(frame11,'Hard QCD processes').grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame11,11,('f','{_i','f','{_i','arrow','f','{_i','f','{_i')      ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[11],         bg=self.theBackGround        ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame11,12,('f','{_i','fbar','{_i','arrow','f','{_k','fbar','{_k')).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[12],         bg=self.theBackGround        ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame11,13,('f','{_i','fbar','{_i','arrow','g','[g')            ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[13],         bg=self.theBackGround        ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame11,28,('f','{_i','g','arrow','f','{_i','g')                ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[28],         bg=self.theBackGround        ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame11,53,('g','g','arrow','f','{_k','fbar','{_k')             ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[53],         bg=self.theBackGround        ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame11,68,('g','g','arrow','g','g')                          ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[68],         bg=self.theBackGround        ).grid(row=6,column=1,sticky=NSEW)

        #SOFT QCD
        TitleProCan(frame12,'Soft QCD processes' ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsTextCan(frame12,91,  'elastic scattering'                            ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame12,variable=self.subprocess[91],         bg=self.theBackGround        ).grid(row=1,column=1,sticky=NSEW)
        PhysicsTextCan(frame12,92,  'single diffraction (XB)'                       ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame12,variable=self.subprocess[92],         bg=self.theBackGround        ).grid(row=2,column=1,sticky=NSEW)
        PhysicsTextCan(frame12,93,  'single diffraction (AX)'                       ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame12,variable=self.subprocess[93],         bg=self.theBackGround        ).grid(row=3,column=1,sticky=NSEW)
        PhysicsTextCan(frame12,94,  'double diffraction'                            ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame12,variable=self.subprocess[94],         bg=self.theBackGround        ).grid(row=4,column=1,sticky=NSEW)
        PhysicsTextCan(frame12,95,'low-p| production'                               ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame12,variable=self.subprocess[95],         bg=self.theBackGround        ).grid(row=5,column=1,sticky=NSEW)
        BlankCan(frame12).grid(row=6,column=0,columnspan=2,sticky=NSEW)
#        Label(frame12,bg=self.theBackGround,                                fg='red'   ).grid(row=6,column=0,columnspan=2,sticky=NSEW)
        #OPEN HEAVY FLAVOUR
        TitleProCan(frame13,'Open heavy flavour'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame13,81,('f','{_i','fbar','{_i','arrow','Q','{_k','Qbar','{_k')).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame13,variable=self.subprocess[81],         bg=self.theBackGround        ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame13,82,('g','g','arrow','Q','{_k','Qbar','{_k' )            ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame13,variable=self.subprocess[82],         bg=self.theBackGround        ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame13,83,('q','{_i','f','{_j','arrow','Q','{_k','f','{_l')      ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame13,variable=self.subprocess[83],         bg=self.theBackGround        ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame13,84,('g','[g','arrow','Q','{_k','Qbar','{_k')            ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame13,variable=self.subprocess[84],         bg=self.theBackGround        ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame13,85, ( '[g','[g','arrow', 'F','{_k','Fbar','{_k')        ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame13,variable=self.subprocess[85],         bg=self.theBackGround        ).grid(row=5,column=1,sticky=NSEW)
        BlankCan(frame13).grid(row=6,column=0,columnspan=2,sticky=NSEW)
          #CLOSED HEAVY FLAVOUR
        TitleProCan(frame21,'Closed heavy flavour', ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame21,86,('g','g','arrow','J','/','[y','g')                 ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[86],         bg=self.theBackGround        ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame21,87 , ('g','g','arrow','[k','_0','_c','g')             ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[87],         bg=self.theBackGround        ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame21,88 , ('g','g','arrow','[k','_1','_c','g')             ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[88],         bg=self.theBackGround        ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame21,89 , ('g','g','arrow','[k','_2','_c','g')             ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[89],         bg=self.theBackGround        ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame21,104 , ('g','g','arrow','[k','_0','_c')                ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[104],        bg=self.theBackGround        ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame21,105 , ('g','g','arrow','[k','_2','_c')                ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[105],        bg=self.theBackGround        ).grid(row=6,column=1,sticky=NSEW)
        PhysicsProCan(frame21,106,('g','g','arrow','J','/','[y','g')                ).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[106],        bg=self.theBackGround        ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame21,107,('g','[g','arrow','J','/','[y','g')               ).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[107],        bg=self.theBackGround        ).grid(row=8,column=1,sticky=NSEW)
        PhysicsProCan(frame21,108,('[g','[g','arrow','J','/','[y','[g')             ).grid(row=9,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[108],        bg=self.theBackGround        ).grid(row=9,column=1,sticky=NSEW)
         #PROMPT PHOTONS
        TitleProCan(frame22,'Prompt photons'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame22,14,('f','{_i','fbar','{_i','arrow','g','[g')          ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame22,variable=self.subprocess[14],         bg=self.theBackGround        ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame22,18,  ('f','{_i','fbar','{_i','arrow','[g','[g')       ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame22,variable=self.subprocess[18],         bg=self.theBackGround        ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame22,29,('f','{_i','g','arrow','f','{_i','[g')             ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame22,variable=self.subprocess[29],         bg=self.theBackGround        ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame22,114,('g','g','arrow','[g','[g')                       ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame22,variable=self.subprocess[114],        bg=self.theBackGround        ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame22,115,  ('g','g','arrow', 'g','[g')                     ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame22,variable=self.subprocess[115],        bg=self.theBackGround        ).grid(row=5,column=1,sticky=NSEW)
        #DIS
        TitleProCan(frame22,'Deep inelastic scatt'    ).grid(row=6,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame22,10,  ('f','{_i','f','{_j','arrow','f','{_i','f','{_j')).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame22,variable=self.subprocess[10],         bg=self.theBackGround        ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame22,99, ( '[g','^*','f','{_j','arrow','f','{_i')          ).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame22,variable=self.subprocess[99],         bg=self.theBackGround        ).grid(row=8,column=1,sticky=NSEW)
        BlankCan(frame22).grid(row=9,column=0,columnspan=2,sticky=NSEW)
        #HEAVY SM HIGGS
        TitleProCan(frame23,'Heavy SM Higgs'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame23,5,  ('Z','^0','Z','^0','arrow','h','^0')              ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame23,variable=self.subprocess[5],         bg=self.theBackGround         ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame23,8,  ('W','%5^+','W','%5^-','arrow','h','^0')          ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame23,variable=self.subprocess[8],         bg=self.theBackGround         ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame23,71,  ('Z','^0','%-5_L','Z','^0','%-5_L','arrow','Z','^0','%-5_L','Z','^0','%-5_L')              ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame23,variable=self.subprocess[71],         bg=self.theBackGround        ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame23,72,  ('Z','^0','%-5_L','Z','^0','%-5_L','arrow','W','%5^+','%-5_L','W','%5^-','%-5_L') ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame23,variable=self.subprocess[72],         bg=self.theBackGround        ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame23,73,  ('Z','^0','%-5_L','W','%5^/pm','%-5_L','arrow','Z','^0','%-5_L','W','%5^/pm','%-5_L') ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame23,variable=self.subprocess[73],         bg=self.theBackGround        ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame23,76,  ('W','%5^+','%-5_L','W','%5^-','%-5_L','arrow','Z','^0','%-5_L','Z','^0','%-5_L') ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame23,variable=self.subprocess[76],         bg=self.theBackGround        ).grid(row=6,column=1,sticky=NSEW)
        PhysicsProCan(frame23,77,  ('W','%5^/pm','%-5_L','W','%5^/pm','%-5_L','arrow','W','%5^/pm','%-5_L','W','%5^/pm','%-5_L') ).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame23,variable=self.subprocess[77],         bg=self.theBackGround        ).grid(row=7,column=1,sticky=NSEW)
        BlankCan(frame23).grid(row=8,column=0,columnspan=2,sticky=NSEW)
        BlankCan(frame23).grid(row=9,column=0,columnspan=2,sticky=NSEW)
        #W/Z PRODUCTION
        fifi = ('f','{_i','fbar','{_i','arrow')
        fifj = ('f','{_i','fbar','{_j','arrow')
        fig  = ('f','{_i','g','arrow')
        figam= ('f','{_i','[g','arrow')
        fkfk = ('f','{_k','fbar','{_k')
        fkfl = ('f','{_k','fbar','{_l')
        qiqi = ('q','{_i','qbar','{_i','arrow')
        TitleProCan(frame31,'W/Z Production'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame31,1,  fifi+('[g','^*','/','Z','^0')                     ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[1],         bg=self.theBackGround         ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame31,2,  fifj+('W','%5^/pm')                               ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[2],         bg=self.theBackGround         ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame31,22,  fifi+('Z','^0','Z','^0')                         ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[22],        bg=self.theBackGround         ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame31,23,  fifj+('Z','^0','W','%5^/pm')                     ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[23],        bg=self.theBackGround         ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame31,25,  fifi+('W','%5^+','W','%5^-')                     ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[25],        bg=self.theBackGround         ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame31,15,  fifi+('g','Z','^0')                              ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[15],        bg=self.theBackGround         ).grid(row=6,column=1,sticky=NSEW)
        PhysicsProCan(frame31,16,  fifj+('g','W','%5^/pm')                          ).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[16],        bg=self.theBackGround         ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame31,30,  fig +('f','{_i','Z','^0')                        ).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[30],        bg=self.theBackGround         ).grid(row=8,column=1,sticky=NSEW)
        PhysicsProCan(frame31,31,  fig +('f','{_k','W','%5^/pm')                    ).grid(row=9,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[31],        bg=self.theBackGround         ).grid(row=9,column=1,sticky=NSEW)
        PhysicsProCan(frame31,19,  fifi+('[g','Z','^0')                            ).grid(row=10,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[19],        bg=self.theBackGround        ).grid(row=10,column=1,sticky=NSEW)
        PhysicsProCan(frame31,20,  fifj+('[g','W','%5^/pm')                        ).grid(row=11,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[20],        bg=self.theBackGround        ).grid(row=11,column=1,sticky=NSEW)
        PhysicsProCan(frame31,35,  figam+('[g','Z','^0')                           ).grid(row=12,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[35],        bg=self.theBackGround        ).grid(row=12,column=1,sticky=NSEW)
        PhysicsProCan(frame31,36,  figam+('[g','W','%5^/pm')                       ).grid(row=13,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[36],        bg=self.theBackGround        ).grid(row=13,column=1,sticky=NSEW)
        PhysicsProCan(frame31,69,  ('[g','[g','arrow','W','%5^+','W','%5^-',)      ).grid(row=14,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[69],        bg=self.theBackGround        ).grid(row=14,column=1,sticky=NSEW)
        PhysicsProCan(frame31,70,  ('[g','W','%5/pm','arrow','Z','^0','W','%5/pm') ).grid(row=15,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[70],        bg=self.theBackGround        ).grid(row=15,column=1,sticky=NSEW)

        #Photon-induced
        TitleProCan(frame32,'Photon-induced'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame32,33,  figam+fig[:-1]                                   ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[33],         bg=self.theBackGround        ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame32,34,  figam+figam[:-1]                                 ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[34],         bg=self.theBackGround        ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame32,54,  ('g','[g','arrow','f','{_k','fbar','{_k')        ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[54],         bg=self.theBackGround        ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame32,58,  ('[g','[g','arrow','f','{_k','fbar','{_k')       ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[58],         bg=self.theBackGround        ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame32,131,  ('f','{_i','[g','^*','%-5_T','arrow')+fig[:-1]  ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[131],        bg=self.theBackGround        ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame32,132,  ('f','{_i','[g','^*','%-5_L','arrow')+fig[:-1]  ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[132],        bg=self.theBackGround        ).grid(row=6,column=1,sticky=NSEW)
        PhysicsProCan(frame32,133,  ('f','{_i','[g','^*','%-5_T','arrow')+figam[:-1]).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[133],        bg=self.theBackGround        ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame32,134,  ('f','{_i','[g','^*','%-5_L','arrow')+figam[:-1]).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[134],        bg=self.theBackGround        ).grid(row=8,column=1,sticky=NSEW)
        PhysicsProCan(frame32,135,  ('g','[g','^*','%-5_T','arrow')+fifi[:-1]       ).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[135],        bg=self.theBackGround        ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame32,136,  ('g','[g','^*','%-5_L','arrow')+fifi[:-1]       ).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[136],        bg=self.theBackGround        ).grid(row=8,column=1,sticky=NSEW)
        PhysicsProCan(frame32,137,('[g','^*','%-5_T','[g','^*','%-5_T','arrow')+fifi[:-1]).grid(row=9,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[137],        bg=self.theBackGround        ).grid(row=9,column=1,sticky=NSEW)
        PhysicsProCan(frame32,138,('[g','^*','%-5_T','[g','^*','%-5_L','arrow')+fifi[:-1]).grid(row=10,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[138],        bg=self.theBackGround       ).grid(row=10,column=1,sticky=NSEW)
        PhysicsProCan(frame32,139,('[g','^*','%-5_L','[g','^*','%-5_T','arrow')+fifi[:-1]).grid(row=11,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[139],        bg=self.theBackGround       ).grid(row=11,column=1,sticky=NSEW)
        PhysicsProCan(frame32,140,('[g','^*','%-5_L','[g','^*','%-5_L','arrow')+fifi[:-1]).grid(row=12,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[140],        bg=self.theBackGround       ).grid(row=12,column=1,sticky=NSEW)
        PhysicsProCan(frame32,80,('q','{_i','[g','arrow','q','%1{_k','[p','%2^/pm')).grid(row=13,column=0,sticky=NSEW)
        Checkbutton(frame32,variable=self.subprocess[80],        bg=self.theBackGround        ).grid(row=13,column=1,sticky=NSEW)
        BlankCan(frame32).grid(row=14,column=0,columnspan=2,sticky=NSEW)
        BlankCan(frame32).grid(row=15,column=0,columnspan=2,sticky=NSEW)

        #LIGHT SM HIGGS
        TitleProCan(frame33,'Light SM Higgs'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame33,3,  fifi+('h','^0')                                   ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[3],         bg=self.theBackGround         ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame33,24,  fifi+('Z','^0','h','^0')                         ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[24],        bg=self.theBackGround         ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame33,26,  fifi+('W','%5^/pm','h','^0')                     ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[26],        bg=self.theBackGround         ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame33,102,  ('g','g','arrow','h','^0')                      ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[102],       bg=self.theBackGround         ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame33,103,  ('[g','[g','arrow','h','^0')                    ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[103],       bg=self.theBackGround         ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame33,110,  fifi+('[g','h','^0')                            ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[103],       bg=self.theBackGround         ).grid(row=6,column=1,sticky=NSEW)
        PhysicsProCan(frame33,121,('g','g','arrow','Q','%1{_k','Qbar','%1{_k','h','^0')).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[121],       bg=self.theBackGround         ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame33,122,('q','{_i','qbar','{_i','arrow','Q','%1{_k','Qbar','%1{_k','h','^0')).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[122],       bg=self.theBackGround         ).grid(row=8,column=1,sticky=NSEW)
        PhysicsProCan(frame33,123,('f','{_i','f','{_j','arrow','f','{_i','f','{_j','h','^0')).grid(row=9,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[123],       bg=self.theBackGround         ).grid(row=9,column=1,sticky=NSEW)
        PhysicsProCan(frame33,124,('f','{_i','f','{_j','arrow','f','{_k','f','{_l','h','^0')).grid(row=10,column=0,sticky=NSEW)
        Checkbutton(frame33,variable=self.subprocess[124],       bg=self.theBackGround         ).grid(row=10,column=1,sticky=NSEW)
        BlankCan(frame33).grid(row=11,column=0,columnspan=2,sticky=NSEW)
        BlankCan(frame33).grid(row=12,column=0,columnspan=2,sticky=NSEW)
        BlankCan(frame33).grid(row=13,column=0,columnspan=2,sticky=NSEW)
        BlankCan(frame33).grid(row=14,column=0,columnspan=2,sticky=NSEW)
        BlankCan(frame33).grid(row=15,column=0,columnspan=2,sticky=NSEW)
      #NON SM PROCESSES
        self.smbut = Button(self,text='Non-SM Processes',fg='black',command=self.nonSM)
        self.smbut.grid(row=4,column=0,sticky=NSEW)
       #SUSY
        self.susybut = Button(self,text='SUSY Processes',fg='black',command=self.SUSY)
        self.susybut.grid(row=4,column=1,sticky=NSEW)
         
       #OK BUTTON
        self.okbut = Button(self,text='OK',fg='black',command=self.OK)
        self.okbut.grid(row=4,column=2,sticky=NSEW)
        self.master.wait_window()

    def nonSM(self):
        for id in self.msubs.keys():
            self.msubs[id] = self.subprocess[id].get()
        self.disableEnable(DISABLED)
        PysubsMsubNonSM(Toplevel(),self.msubs)
        self.disableEnable(NORMAL)
        for id in self.msubs.keys():
            self.subprocess[id].set(self.msubs[id])
    def SUSY(self):
        for id in self.msubs.keys():
            self.msubs[id] = self.subprocess[id].get()
        self.disableEnable(DISABLED)
        showinfo('Not Implemented','SUSY Channels not yet ready!\n SORRY')
        self.disableEnable(NORMAL)
        for id in self.msubs.keys():
            self.subprocess[id].set(self.msubs[id])
    def OK(self):
        for id in self.msubs.keys():
            self.msubs[id] = self.subprocess[id].get()
        self.master.destroy()

    def disableEnable(self,STATE):
        self.smbut.config(state=STATE)
        self.susybut.config(state=STATE)
        self.okbut.config(state=STATE)
#######################################
if __name__=='__main__':
    root = Tk()
    pysubs = {}
    pysubs['msub'] = {}
    for i in range(1,200):
        pysubs['msub'][i] = 0

    PysubsMsub(root,pysubs['msub'])
    root.mainloop()
