from Tkinter import *
import  sys
from pysubs_kfin import PysubsKfin
from pysubs_ckin import PysubsCkin
from pysubs_msub import PysubsMsub
from pysubs_msel import *
from pydat3_mdcy import Pydat3Mdcy
from pysubs_util import PysubsUtil
from pypars import Pypars
from pydat1 import Pydat1
from pydat2 import Pydat2
from textMaker import textMaker
from tkFileDialog import asksaveasfile
from tkMessageBox import *
from gendisplay import GenDisplay
from HelpMenu import HelpMenuMain
from  tkFileDialog import *
import pickle
######################
#the variables
######################
pysubs = {}
pysubs['msel']    = 0
pysubs['msub']    = {}
pysubs['kfin']    = {}
pysubs['kfin'][1] = {}
pysubs['kfin'][2] = {}
pysubs['ckin']    = {}
######################
pydat3            = {}
pydat3['mdcy']    = {}
pydat3['mdcy'][1] = {}
pydat3['mdme']    = {}
pydat3['mdme'][1] = {}
pydat3['mdme'][2] = {}
pydat3['brat']    = {}
######################
pypars = {}
pypars['mstp'] = {}
pypars['parp'] = {}
pypars['msti'] = {}
pypars['pari'] = {}
######################
pydat1 = {}
pydat1['mstu'] = {}
pydat1['paru'] = {}
pydat1['mstj'] = {}
pydat1['parj'] = {}
######################
pydat2 = {}
pydat2['pmas'] = {}
######################
mogiid = '#@PYMOGIFILE@#'
######################
for i in range(1,400):
    pysubs['msub'][i] = 0

pysubsHelper = PysubsUtil()
class GeneratorsTest(Frame):
    def __init__(self, master=None):
        Frame.__init__(self,master)
        self.master=master
        master.title('PyMoGi (PythiaModule Graphical Interface)')
        master.geometry('320x251+432+171')
        master.config(background="#46d900")
        self.master.protocol('WM_DELETE_WINDOW', self.Exit)
        self.pack()
##################################
# Setup help menus
        top = HelpMenuMain(self.master,"#46d900")
        self.master.config(menu=top)
##################################
        self.lab24 = Label (master)
        self.lab24.place(in_=master,x=40,y=10)
        self.lab24.configure(background="#46d900")
        self.lab24.configure(borderwidth="1")
        self.lab24.configure(font="Helvetica 18 bold")
        self.lab24.configure(foreground="#c80000")
        self.lab24.configure(text="Generators PythiaModule")

        self.fra25 = Frame (master)
        self.fra25.place(in_=master,x=10,y=40)
        self.fra25.configure(relief=GROOVE)
        self.fra25.configure(background="#46d900")
        self.fra25.configure(borderwidth="2")
        self.fra25.configure(height="80")
        self.fra25.configure(relief="groove")
        self.fra25.configure(width="300")

        self.fra25_but26 = Button (self.fra25)
        self.fra25_but26.place(in_=self.fra25,x=20,y=5)
        self.fra25_but26.configure(command=self.mPysubsMsel)
        self.fra25_but26.configure(foreground="#0000c8")
        self.fra25_but26.configure(text="PYSUBS/MSEL",width="12")

        self.fra25_but27 = Button (self.fra25)
        self.fra25_but27.place(in_=self.fra25,x=160,y=5)
        self.fra25_but27.configure(command=self.mPysubsMsub)
        self.fra25_but27.configure(foreground="#0000c8")
        self.fra25_but27.configure(text="PYSUBS/MSUB",width="12")

        self.fra25_but28 = Button (self.fra25)
        self.fra25_but28.place(in_=self.fra25,x=20,y=40)
        self.fra25_but28.configure(command=self.mPysubsKfin)
        self.fra25_but28.configure(foreground="#0000c8")
        self.fra25_but28.configure(text="PYSUBS/KFIN",width="12")

        self.fra25_but29 = Button (self.fra25)
        self.fra25_but29.place(in_=self.fra25,x=160,y=40)
        self.fra25_but29.configure(command=self.mPysubsCkin)
        self.fra25_but29.configure(foreground="#0000c8")
        self.fra25_but29.configure(text="PYSUBS/CKIN",width="12")

        self.fra30 = Frame (master)
        self.fra30.place(in_=master,x=10,y=130)
        self.fra30.configure(relief=GROOVE)
        self.fra30.configure(background="#46d900")
        self.fra30.configure(borderwidth="2")
        self.fra30.configure(height="75")
        self.fra30.configure(relief="groove")
        self.fra30.configure(width="300")

        self.fra30_but31 = Button (self.fra30)
        self.fra30_but31.place(in_=self.fra30,x=20,y=40)
        self.fra30_but31.configure(command=self.mPydat3Mdcy)
        self.fra30_but31.configure(foreground="#0000c8")
        self.fra30_but31.configure(text="PYDAT3",width="12")

        self.fra30_but32 = Button (self.fra30)
        self.fra30_but32.place(in_=self.fra30,x=160,y=5)
        self.fra30_but32.configure(command=self.mPydat2)
        self.fra30_but32.configure(foreground="#0000c8")
        self.fra30_but32.configure(text="PYDAT2",width="12")

        self.fra30_but33 = Button (self.fra30)
        self.fra30_but33.place(in_=self.fra30,x=20,y=5)
        self.fra30_but33.configure(command=self.mPydat1)
        self.fra30_but33.configure(foreground="#0000c8")
        self.fra30_but33.configure(text="PYDAT1",width="12")

        self.fra30_but34 = Button (self.fra30)
        self.fra30_but34.place(in_=self.fra30,x=160,y=40)
        self.fra30_but34.configure(command=self.mPypars)
        self.fra30_but34.configure(foreground="#0000c8")
        self.fra30_but34.configure(text="PYPARS",width="12")

        self.but32 = Button (master)
        self.but32.place(in_=master,x=20,y=210)
        self.but32.configure(command=gotoView)
        self.but32.configure(foreground="#c80000")
        self.but32.configure(text="View")

        self.but32 = Button (master)
        self.but32.place(in_=master,x=95,y=210)
        self.but32.configure(command=gotoSave)
        self.but32.configure(foreground="#c80000")
        self.but32.configure(text="Save")

        self.but35 = Button (master)
        self.but35.place(in_=master,x=170,y=210)
        self.but35.configure(command=gotoLoad)
        self.but35.configure(foreground="#c80000")
        self.but35.configure(text="Load")

        self.but34 = Button (master)
        self.but34.place(in_=master,x=240,y=210)
        self.but34.configure(command=self.Exit)
        self.but34.configure(foreground="#c80000")
        self.but34.configure(text="Exit")



##################################
    def Exit(self):
        if askyesno('Exit?','Really Quit? \nAll unsaved changes will be lost!'):
            self.master.destroy()
    def disableEnable(self,STATE):
        self.fra25_but26.config(state=STATE)
        self.fra25_but27.config(state=STATE)
        self.fra25_but28.config(state=STATE)
        self.fra25_but29.config(state=STATE)
        self.fra30_but31.config(state=STATE)
        self.fra30_but32.config(state=STATE)
        self.fra30_but33.config(state=STATE)
        self.fra30_but34.config(state=STATE)

    def mPydat3Mdcy(self):
        self.disableEnable(DISABLED)
        makePydat3Mdcy()
        self.disableEnable(NORMAL)
    def mPysubsMsub(self):
        self.disableEnable(DISABLED)
        makePysubsMsub()
        self.disableEnable(NORMAL)
    def mPysubsMsel(self):
        self.disableEnable(DISABLED)
        makePysubsMsel()
        self.disableEnable(NORMAL)
    def mPydat3Mdcy(self):
        self.disableEnable(DISABLED)
        makePydat3Mdcy()
        self.disableEnable(NORMAL)
    def mPysubsKfin(self):
        self.disableEnable(DISABLED)
        makePysubsKfin()
        self.disableEnable(NORMAL)
    def mPysubsCkin(self):
        self.disableEnable(DISABLED)
        makePysubsCkin()
        self.disableEnable(NORMAL)
    def mPypars(self):
        self.disableEnable(DISABLED)
        makePypars()
        self.disableEnable(NORMAL)
    def mPydat1(self):
        self.disableEnable(DISABLED)
        makePydat1()
        self.disableEnable(NORMAL)
    def mPydat2(self):
        self.disableEnable(DISABLED)
        makePydat2()
        self.disableEnable(NORMAL)



def makePysubsMsel():
    PysubsMsel(Toplevel(),pysubs)
    pysubsHelper.setMsub(pysubs)
def makePysubsMsub():
    PysubsMsub(Toplevel(),pysubs['msub'])
    pysubsHelper.setMsel(pysubs)
def makePydat3Mdcy():
    Pydat3Mdcy(Toplevel(),pydat3)
def makePysubsKfin():
    PysubsKfin(Toplevel(),pysubs['kfin'])
def makePysubsCkin():
    PysubsCkin(Toplevel(),pysubs['ckin'])
def makePypars():
    Pypars(Toplevel(),pypars)
def makePydat1():
    Pydat1(Toplevel(),pydat1)
def makePydat2():
    Pydat2(Toplevel(),pydat2)
def gotoView():
    textus = textMaker(pysubs,pydat3,pypars,pydat1,pydat2)
    GenDisplay(Toplevel(),textus)
def gotoSave():
    Saver(Toplevel())
def gotoSaveTxt():
    text = textMaker(pysubs,pydat3,pypars,pydat1,pydat2)
    text = 'PythiaModule.PythiaCommand = {\n'+text+'};'
    file = asksaveasfile()
    if file:
        file.write(text)
        file.close()
def gotoSavePyt():
    text = textMaker(pysubs,pydat3,pypars,pydat1,pydat2)
    text = 'PythiaModule.PythiaCommand = [\n'+text+']'
    file = asksaveasfile()
    if file:
        file.write(text)
        file.close()
def gotoSavePym():
    file = asksaveasfile()
    if file:        
        pickle.dump(mogiid,file)
        pickle.dump(pysubs,file)
        pickle.dump(pydat3,file)
        pickle.dump(pypars,file)
        pickle.dump(pydat1,file)
        pickle.dump(pydat2,file)
def gotoLoad():
    file = askopenfile()
    if file:
        try:
            a = pickle.load(file)
        except:
            showerror('Error',"There was a problem loading the selected file!\nAre you sure it's a PyMoGi file?")
            return
        if a == mogiid:
            a = pickle.load(file)
            for b in a.keys():
                pysubs[b] = a[b]
            a = pickle.load(file)
            for b in a.keys():
                pydat3[b] = a[b]
            a = pickle.load(file)
            for b in a.keys():
                pypars[b] = a[b]
            a = pickle.load(file)
            for b in a.keys():
                pydat1[b] = a[b]
            a = pickle.load(file)
            for b in a.keys():
                pydat2[b] = a[b]
        else:
            showerror('Error',"There was a problem loading the selected file\n are you sure it's a PyMoGi file?")
            
#############################################
#saver class
class Saver(Frame):
    def __init__(self,master):
        Frame.__init__(self,master)
        self.pack()
        self.config(bg="#46d900")
        Label(self,bg="#46d900",text='In which format do you wish to save?').grid(row=0,column=0,columnspan=3)
        Button(self,text='txt file',command=gotoSaveTxt,width=10).grid(row=1,column=0)
        Button(self,text='python file',command=gotoSavePyt,width=10).grid(row=1,column=1)
        Button(self,text='PyMoGi file',command=gotoSavePym,width=10).grid(row=1,column=2)
        Button(self,text='Exit',command=self.Exit).grid(row=2,column=1)
    def Exit(self):
        self.master.destroy()

#############################################
if __name__ == '__main__':
    root = Tk()
    GeneratorsTest (root)
    root.mainloop()
