from Tkinter import *
from tkMessageBox import *
import Pmw
from findkccode import FindKcCode
class HelpMenu(Menu):
    def __init__(self,master,bckg):
        Menu.__init__(self,master)
        self.config(bg=bckg)
        self.master = master
        self.file1 = Menu(self,bg=bckg)
        self.file1.add_command(label='Pythia',command=(lambda self=self: self.doAbout('Pythia Help','thePythiaHelp.txt')))
        self.file1.add_command(label='PyMoGi',command=(lambda self=self: self.doHelp('PyMoGi Help','thePymogiHelp.txt')))
        self.file1.add_command(label='Find KC code',command=self.findKcCode)
        self.add_cascade(label='Help' ,menu=self.file1)

    def notdone(self):
        showerror('not ready','not ready')
    def doAbout(self,theLabel,txtfile):
        tl = Toplevel()
        frame = Frame(tl)
        tl.title(theLabel)
        frame.pack()
        theText = open('lib/TxtFiles/'+txtfile).read()
        Label(frame,text=theText,bg='white').pack()
    def findKcCode(self):
        FindKcCode(Toplevel())
#        Label(Toplevel(),text='hello').pack()


    def doHelp(self,theLabel,txtfile):
        St = Pmw.ScrolledText(Toplevel(),borderframe=1,
                              labelpos=N,label_text=theLabel,label_bg='white',
                              hull_width=100,hull_height=200,text_bg='white',
                              text_fg='#0000c8',label_fg='#c80000')
        St.config(bg='white')
        St.importfile('lib/TxtFiles/'+txtfile)
        St.pack(fill=BOTH,expand=1)

        
class HelpMenuMain(HelpMenu):
    def __init__(self,master,bckg):
        HelpMenu.__init__(self,master,bckg)
        file2 = Menu(self,bg=bckg)
        file2.add_command(label='Pythia',command=(lambda self=self: self.doAbout('About Pythia','thePythiaText.txt')))
        file2.add_command(label='PyMoGi',command=(lambda self=self: self.doAbout('About PyMogi','thePymogiText.txt')))
        file2.add_command(label='Author',command=(lambda self=self: self.doAbout('About Author','theAuthorText.txt')))
        self.add_cascade(label='About' ,menu=file2)

class HelpMenuInd(HelpMenu):
    def __init__(self,master,bckg,theTitle,theFile):
        HelpMenu.__init__(self,master,bckg)
        self.file1.add_command(label=theTitle,command=(lambda self=self, theTitle=theTitle, theFile=theFile: self.doHelp(theTitle+' Help',theFile)))
