from Tkinter import *
from tkMessageBox import *
import string
from HelpMenu import HelpMenuInd
class Pydat1(Frame):
    def __init__(self,master,pydat1):
        Frame.__init__(self,master)
        self.pack()
        master.focus_set()
#        master.grab_set()
##################################
# Setup help menus
        top = HelpMenuInd(self.master,"#46d900",'pydat1','pydat1.txt')
        self.master.config(menu=top)
##################################
        self.master.protocol('WM_DELETE_WINDOW', self.OK)
        options = ()
        self.config(bg="#46d900")
        self.pydat1 = pydat1
        self.pykey = StringVar()
        self.pykey.set('mstu')
        Label(self,text='set PYDAT1',bg="#46d900",font="Helvetica 16 bold").grid(row=0,column=0,columnspan=6)
        OptionMenu(self,self.pykey,'mstu','paru','mstj','parj').grid(row=1,column=0)
        self.ent1 = Entry(self)
        self.ent1.grid(row=1,column=1)
        self.ent2 = Entry(self)
        self.ent2.grid(row=1,column=2)
        Button(self,text='Add',command=self.Add,width=12).grid(row=2,column=0)
        Button(self,text='Remove',command=self.Remove,width=12).grid(row=2,column=1)
        Button(self,text='View',command=self.View,width=12).grid(row=2,column=2)
        Button(self,text='OK',command=self.OK,width=5).grid(row=2,column=3)
        self.wait_window()
    def Add(self):
        try:
            ent1 = string.atoi(self.ent1.get())
        except ValueError:
            showerror('Error','You must enter an integer number')
            return
        try:
            ent2 = string.atoi(self.ent2.get())
        except ValueError:
            showerror('Error','You must enter a number')
            return
        self.pydat1[self.pykey.get()][ent1] = ent2            
    def Remove(self):
        try:
            ent1 = string.atoi(self.ent1.get())
        except ValueError:
            showerror('Error','You must enter a integer number')
            return
        if ent1 in self.pydat1[self.pykey.get()].keys():
            del(self.pydat1[self.pykey.get()][ent1])
        else:
                showinfo('pydat1 Remove','A value for this pydat1 has not been set')
    def View(self):
        if not self.pydat1['mstu'] and not self.pydat1['paru'] and not self.pydat1['mstj'] and not self.pydat1['parj'] :
            showinfo('pydat1 View','No PYDAT1 values have been set')
            return
        text = Text(Toplevel(),relief=SUNKEN)
        text.pack()
        stuff = ''
        for a in self.pydat1.keys():
            for b in self.pydat1[a].keys():
                stuff += 'PYDAT1'+' '+a+' '+`b`+' '+`self.pydat1[a][b]`+'\n'
        text.insert('1.0',stuff)
    def OK(self):
        if self.ent1.get():
            if int(self.ent1.get()) not in  self.pydat1[self.pykey.get()].keys():
                if not askyesno('Warning','You have unsaved data in the input fields. Exit anyway?'):
                    return
            elif self.pydat1[self.pykey.get()][int(self.ent1.get())] != int(self.ent2.get()):
                if not askyesno('Warning','You have unsaved changes in the input fields. Exit anyway?'):
                    return
        self.master.destroy()    

if __name__ == '__main__':
    root = Tk()
    pydat1 = {}
    pydat1['mstu'] = {}
    pydat1['paru'] = {}
    pydat1['mstj'] = {}
    pydat1['parj'] = {}
    Pydat1(root,pydat1)
    root.mainloop()
