from Tkinter import *
from pythiaallpurposecanvas import *
from HelpMenu import HelpMenuInd
class PysubsMsubNonSM(Frame):
    def __init__(self,master,msubs):
        Frame.__init__(self,master)
        master.focus_set()
        master.grab_set()
        self.master=master
        self.master.title('pysubs msub') 
##################################
# Setup help menus
        top = HelpMenuInd(self.master,"#46d900",'msub','pysubs_msub.txt')
        self.master.config(menu=top)
##################################

        self.pack()
        self.theBackGround = '#46d900'
        self.config(bg=self.theBackGround)
    #the variables
        self.msubs = msubs
        self.subprocess = {}
        for id in self.msubs.keys():
            self.subprocess[id] = IntVar()
            self.subprocess[id].set(self.msubs[id])
        self.makeInterior()
    def makeInterior(self):
        fifi = ('f','{_i','fbar','{_i','arrow')
        fifj = ('f','{_i','fbar','{_j','arrow')
        fig  = ('f','{_i','g','arrow')
        figam= ('f','{_i','[g','arrow')
        fkfk = ('f','{_k','fbar','{_k')
        fkfl = ('f','{_k','fbar','{_l')
        qiqi = ('q','{_i','qbar','{_i','arrow')
        lilj = ('{l','{_i','{l','{_j','arrow')
        lig = ('{l','%1^/pm','%-7{_i','[g','arrow')
        
        Label(self,text='Physics Subprocesses (psubs msub) Non-Standard Model',bg=self.theBackGround,fg='blue').grid(row=0,column=0,columnspan=3,sticky=NSEW)

        frame11 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame11.grid(row=1,column=0,sticky=NSEW)

        frame21 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame21.grid(row=1,column=1,sticky=NSEW)

        frame31 = Frame(self,relief=RIDGE,bd=2,bg=self.theBackGround)
        frame31.grid(row=1,column=2,sticky=NSEW)

        #BSM NEUTRAL HIGGS
        TitleProCan(frame11,'BSM Neutral Higgs'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame11,151, fifj+('H','^0')                                               ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[151],         bg=self.theBackGround         ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame11,152, ('g','g','arrow','H','^0')                                    ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[152],         bg=self.theBackGround         ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame11,153, ('[g','[g','arrow','H','^0')                                  ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[153],         bg=self.theBackGround         ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame11,171, fifi+('Z','^0','H','^0')                                      ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[171],         bg=self.theBackGround         ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame11,172, fifj+('W','%5^/pm','H','^0')                                  ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[172],         bg=self.theBackGround         ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame11,173, fifj+fifj[:-1]+('H','^0')                                     ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[173],         bg=self.theBackGround         ).grid(row=6,column=1,sticky=NSEW)
        PhysicsProCan(frame11,174, fifj+fkfl[:-1]+('H','^0')                                     ).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[174],         bg=self.theBackGround         ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame11,181, ('g','g','arrow','Q','{_k','Qbar','{_k','H','^0')              ).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[181],         bg=self.theBackGround         ).grid(row=8,column=1,sticky=NSEW)
        PhysicsProCan(frame11,182,('q','{_i','qbar','{_i','arrow','Q','{_k','Qbar','{_k','H','^0')).grid(row=9,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[182],         bg=self.theBackGround         ).grid(row=9,column=1,sticky=NSEW)
        PhysicsProCan(frame11,156,fifi+('A','^0')                                                ).grid(row=10,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[156],         bg=self.theBackGround         ).grid(row=10,column=1,sticky=NSEW)
        PhysicsProCan(frame11,157,('g','g','arrow','A','^0')                                     ).grid(row=11,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[157],         bg=self.theBackGround         ).grid(row=11,column=1,sticky=NSEW)
        PhysicsProCan(frame11,158,('[g','[g','arrow','A','^0')                                   ).grid(row=12,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[158],         bg=self.theBackGround         ).grid(row=12,column=1,sticky=NSEW)
        PhysicsProCan(frame11,176,fifi+('Z','^0','A','^0')                                       ).grid(row=13,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[176],         bg=self.theBackGround         ).grid(row=13,column=1,sticky=NSEW)
        PhysicsProCan(frame11,177,fifj+('W','%5^/pm','A','^0')                                   ).grid(row=14,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[177],         bg=self.theBackGround         ).grid(row=14,column=1,sticky=NSEW)
        PhysicsProCan(frame11,178,fifj+fifj[:-1]+('A','^0')                                      ).grid(row=15,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[178],         bg=self.theBackGround         ).grid(row=15,column=1,sticky=NSEW)
        PhysicsProCan(frame11,179,fifj+fkfl+('A','^0')                                           ).grid(row=16,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[179],         bg=self.theBackGround         ).grid(row=16,column=1,sticky=NSEW)
        PhysicsProCan(frame11,186,('g','g','arrow','Q','{_k','Qbar','{_k','A','^0')              ).grid(row=17,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[186],         bg=self.theBackGround         ).grid(row=17,column=1,sticky=NSEW)
        PhysicsProCan(frame11,187,('q','{_i','qbar','{_i','arrow','Q','{_k','Qbar','{_k','A','^0')).grid(row=18,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[187],         bg=self.theBackGround         ).grid(row=18,column=1,sticky=NSEW)
         
        #CHARGEDHIGGS
        TitleProCan(frame11,'Charged Higgs'    ).grid(row=19,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame11,143, fifj+('H','^+')                                               ).grid(row=20,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[143],         bg=self.theBackGround         ).grid(row=20,column=1,sticky=NSEW)
        PhysicsProCan(frame11,161, fig+('f','{_k','H','^+')                                      ).grid(row=21,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[161],         bg=self.theBackGround         ).grid(row=21,column=1,sticky=NSEW)
        #HIGGS PAIRS
        TitleProCan(frame11,'Higgs Pairs'    ).grid(row=22,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame11,297,  fifj+('H','%3^/pm','h','^0')                                 ).grid(row=23,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[297],         bg=self.theBackGround         ).grid(row=23,column=1,sticky=NSEW)
        PhysicsProCan(frame11,298,  fifj+('H','%3^/pm','H','^0')                                 ).grid(row=24,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[298],         bg=self.theBackGround         ).grid(row=24,column=1,sticky=NSEW)
        PhysicsProCan(frame11,299,  fifi+('A','^0','h','^0')                                     ).grid(row=25,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[299],         bg=self.theBackGround         ).grid(row=25,column=1,sticky=NSEW)
        PhysicsProCan(frame11,300,  fifi+('A','^0','H','^0')                                     ).grid(row=26,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[300],         bg=self.theBackGround         ).grid(row=26,column=1,sticky=NSEW)
        PhysicsProCan(frame11,301,  fifi+('H','^+','H','^-')                                     ).grid(row=27,column=0,sticky=NSEW)
        Checkbutton(frame11,variable=self.subprocess[301],         bg=self.theBackGround         ).grid(row=27,column=1,sticky=NSEW)
         #NEW GAUGE BOSONS 
        TitleProCan(frame21,'New Gauge Bosons'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame21,141,  fifi+('[g','/','Z','%3^0',"%3/Z'","%6^0")                    ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[141],         bg=self.theBackGround         ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame21,142,  fifj+("W'","%8^+")                                           ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[142],         bg=self.theBackGround         ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame21,144,  fifj+('R',)                                                  ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[144],         bg=self.theBackGround         ).grid(row=3,column=1,sticky=NSEW)
        #Technicolour
        TitleProCan(frame21,'Technicolour'    ).grid(row=4,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame21,149,  ('g','g','arrow','[h','%5_tc')                               ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[149],         bg=self.theBackGround         ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame21,191,  fifi+('[r','^0','_tc')                                       ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[191],         bg=self.theBackGround         ).grid(row=6,column=1,sticky=NSEW)
        PhysicsProCan(frame21,192,  fifj+('[r','^+','_tc')                                       ).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[192],         bg=self.theBackGround         ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame21,193,  fifi+('[w','^0','_tc')                                       ).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[193],         bg=self.theBackGround         ).grid(row=8,column=1,sticky=NSEW)
        PhysicsProCan(frame21,194,  fifi+fkfk                                                    ).grid(row=9,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[194],         bg=self.theBackGround         ).grid(row=9,column=1,sticky=NSEW)
        PhysicsProCan(frame21,195,  fifj+fkfl                                                    ).grid(row=10,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[195],         bg=self.theBackGround         ).grid(row=10,column=1,sticky=NSEW)
        PhysicsProCan(frame21,361,  fifi+('W','%5^+','%-7_L','W','%5^-','%-7_L')                 ).grid(row=11,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[361],         bg=self.theBackGround         ).grid(row=11,column=1,sticky=NSEW)
        PhysicsProCan(frame21,362,  fifi+('W','%5^/pm','%-7_L','[p','%5^/mp','%-5_tc')           ).grid(row=12,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[362],         bg=self.theBackGround         ).grid(row=12,column=1,sticky=NSEW)
        PhysicsProCan(frame21,363,  fifi+('[p','%3^+','%-5_tc','[p','%3^-','%-5_tc')             ).grid(row=13,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[363],         bg=self.theBackGround         ).grid(row=13,column=1,sticky=NSEW)
        PhysicsProCan(frame21,364,  fifi+('[g','[p','%3^0','%-5_tc')                             ).grid(row=14,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[364],         bg=self.theBackGround         ).grid(row=14,column=1,sticky=NSEW)
        PhysicsProCan(frame21,365,  fifi+('[g','[p',"%-2'",'^0','%-5_tc')                        ).grid(row=15,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[365],         bg=self.theBackGround         ).grid(row=15,column=1,sticky=NSEW)
        PhysicsProCan(frame21,366,  fifi+('Z','%2^0','[p','%5^0','%-5_tc')                       ).grid(row=16,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[366],         bg=self.theBackGround         ).grid(row=16,column=1,sticky=NSEW)
        PhysicsProCan(frame21,367,  fifi+('Z','%2^0','[p',"'",'^0','%-5_tc')                     ).grid(row=17,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[367],         bg=self.theBackGround         ).grid(row=17,column=1,sticky=NSEW)
        PhysicsProCan(frame21,368,  fifi+('W','%5^/pm','[p','%5^/mp','%-5_tc')                   ).grid(row=18,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[368],         bg=self.theBackGround         ).grid(row=18,column=1,sticky=NSEW)
        PhysicsProCan(frame21,370,  fifj+('W','%5^/pm','%-5_L','Z','^0','%-5_L')                 ).grid(row=19,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[370],         bg=self.theBackGround         ).grid(row=19,column=1,sticky=NSEW)
        PhysicsProCan(frame21,371,  fifj+('W','%5^/pm','%-5_L','[p','%5^0','%-5_tc')             ).grid(row=20,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[371],         bg=self.theBackGround         ).grid(row=20,column=1,sticky=NSEW)
        PhysicsProCan(frame21,372,  fifj+('[p','%5^/pm','%-5_tc','%5Z','^0','%-5_L')             ).grid(row=21,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[372],         bg=self.theBackGround         ).grid(row=21,column=1,sticky=NSEW)
        PhysicsProCan(frame21,373,  fifj+('[p','%5^/pm','%-5_tc','%3[p','%5^0','%-5_tc')         ).grid(row=22,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[373],         bg=self.theBackGround         ).grid(row=22,column=1,sticky=NSEW)
        PhysicsProCan(frame21,374,  fifj+('[g','[p','%5^/pm','%-5_tc')                           ).grid(row=23,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[374],         bg=self.theBackGround         ).grid(row=23,column=1,sticky=NSEW)
        PhysicsProCan(frame21,375,  fifj+('Z','^0','[p','%5^/pm','%-5_tc')                       ).grid(row=24,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[375],         bg=self.theBackGround         ).grid(row=24,column=1,sticky=NSEW)
        PhysicsProCan(frame21,376,  fifj+('W','%5^/pm','[p','%5^0','%-5_tc')                     ).grid(row=25,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[376],         bg=self.theBackGround         ).grid(row=25,column=1,sticky=NSEW)
        PhysicsProCan(frame21,377,  fifj+('W','%5^/pm','[p',"%-3'",'^0','%-5_tc')                 ).grid(row=26,column=0,sticky=NSEW)
        Checkbutton(frame21,variable=self.subprocess[377],         bg=self.theBackGround         ).grid(row=26,column=1,sticky=NSEW)
        BlankCan(frame21).grid(row=27,column=0,columnspan=2,sticky=NSEW)
        
        #COMPOSITENESS
        TitleProCan(frame31,'Compositeness'    ).grid(row=0,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame31,146,  ('e','[g','arrow','e','^*')                                  ).grid(row=1,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[146],         bg=self.theBackGround         ).grid(row=1,column=1,sticky=NSEW)
        PhysicsProCan(frame31,147,  ('d','g','arrow','d','^*')                                   ).grid(row=2,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[147],         bg=self.theBackGround         ).grid(row=2,column=1,sticky=NSEW)
        PhysicsProCan(frame31,148,  ('u','g','arrow','u','^*')                                   ).grid(row=3,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[148],         bg=self.theBackGround         ).grid(row=3,column=1,sticky=NSEW)
        PhysicsProCan(frame31,167,  ('q','{_i','q','{_j','arrow','d','^*','%-3q','%2{_k')        ).grid(row=4,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[167],         bg=self.theBackGround         ).grid(row=4,column=1,sticky=NSEW)
        PhysicsProCan(frame31,168,  ('q','{_i','q','{_j','arrow','u','^*','%-3q','%2{_k')        ).grid(row=5,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[168],         bg=self.theBackGround         ).grid(row=5,column=1,sticky=NSEW)
        PhysicsProCan(frame31,169,  ('q','{_i','qbar','{_i','arrow','e','^/pm','e','^*','^/mp')  ).grid(row=6,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[168],         bg=self.theBackGround         ).grid(row=6,column=1,sticky=NSEW)
        PhysicsProCan(frame31,165,  fifi[:-1]+('(','arrow','[g','^*','/Z','%4^0',')','arrow')+fkfk).grid(row=7,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[165],         bg=self.theBackGround         ).grid(row=7,column=1,sticky=NSEW)
        PhysicsProCan(frame31,166,  fifj[:-1]+('(','arrow','W','%5^/pm',')','arrow')+fkfl        ).grid(row=8,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[166],         bg=self.theBackGround         ).grid(row=8,column=1,sticky=NSEW)
        #DOUBLY_CHARGED HIGGS
        TitleProCan(frame31,'Doubly-charged Higgs'    ).grid(row=9,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame31,341,  lilj+('H','%3^/pm','%-7_L','^/pm')                           ).grid(row=10,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[341],         bg=self.theBackGround         ).grid(row=10,column=1,sticky=NSEW)
        PhysicsProCan(frame31,342,  lilj+('H','%3^/pm','%-7_R','^/pm')                           ).grid(row=11,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[342],         bg=self.theBackGround         ).grid(row=11,column=1,sticky=NSEW)
        PhysicsProCan(frame31,343,  lig+('H','%3^/pm','%-7_L','^/pm','e','^/mp')                 ).grid(row=12,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[343],         bg=self.theBackGround         ).grid(row=12,column=1,sticky=NSEW)
        PhysicsProCan(frame31,344,  lig+('H','%3^/pm','%-7_R','^/pm','e','^/mp')                 ).grid(row=13,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[344],         bg=self.theBackGround         ).grid(row=13,column=1,sticky=NSEW)
        PhysicsProCan(frame31,345,  lig+('H','%3^/pm','%-7_L','^/pm','[m','^/mp')                ).grid(row=14,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[345],         bg=self.theBackGround         ).grid(row=14,column=1,sticky=NSEW)
        PhysicsProCan(frame31,346,  lig+('H','%3^/pm','%-7_R','^/pm','[m','^/mp')                ).grid(row=15,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[346],         bg=self.theBackGround         ).grid(row=15,column=1,sticky=NSEW)
        PhysicsProCan(frame31,347,  lig+('H','%3^/pm','%-7_L','^/pm','[t','^/mp')                ).grid(row=16,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[347],         bg=self.theBackGround         ).grid(row=16,column=1,sticky=NSEW)
        PhysicsProCan(frame31,348,  lig+('H','%3^/pm','%-7_R','^/pm','[t','^/mp')                ).grid(row=17,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[348],         bg=self.theBackGround         ).grid(row=17,column=1,sticky=NSEW)
        PhysicsProCan(frame31,349,  fifi+('H','%5^++','%-9_L','H','%5^--','%-9_L')               ).grid(row=18,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[349],         bg=self.theBackGround         ).grid(row=18,column=1,sticky=NSEW)
        PhysicsProCan(frame31,350,  fifi+('H','%5^++','%-9_R','H','%5^--','%-9_R')               ).grid(row=19,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[350],         bg=self.theBackGround         ).grid(row=19,column=1,sticky=NSEW)
        PhysicsProCan(frame31,351,  fifj+fkfl+('H','%5^/pm','^/pm','%-9_L')                      ).grid(row=20,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[351],         bg=self.theBackGround         ).grid(row=20,column=1,sticky=NSEW)
        PhysicsProCan(frame31,352,  fifj+fkfl+('H','%5^/pm','^/pm','%-9_R')                      ).grid(row=21,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[352],         bg=self.theBackGround         ).grid(row=21,column=1,sticky=NSEW)

        #LEPTOQUARKS
        TitleProCan(frame31,'Leptoquarks'    ).grid(row=22,column=0,columnspan=2,sticky=NSEW)
        PhysicsProCan(frame31,145,  ('q','{_i','{l','{_j','arrow','L','_Q')                      ).grid(row=23,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[145],         bg=self.theBackGround         ).grid(row=23,column=1,sticky=NSEW)
        PhysicsProCan(frame31,162,  ('q','{_i','g','arrow','{l','L','_Q')                        ).grid(row=24,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[162],         bg=self.theBackGround         ).grid(row=24,column=1,sticky=NSEW)
        PhysicsProCan(frame31,163,  ('g','g','arrow','L','_Q','Lbar','_Q')                       ).grid(row=25,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[163],         bg=self.theBackGround         ).grid(row=25,column=1,sticky=NSEW)
        PhysicsProCan(frame31,164,  qiqi+('L','_Q','Lbar','_Q')                                  ).grid(row=26,column=0,sticky=NSEW)
        Checkbutton(frame31,variable=self.subprocess[164],         bg=self.theBackGround         ).grid(row=26,column=1,sticky=NSEW)
        BlankCan(frame31).grid(row=27,column=0,columnspan=2,sticky=NSEW)

      #OK BUTTON
        Button(self,text='OK',fg='black',command=self.OK).grid(row=2,column=0,columnspan=3,sticky=NSEW)
        self.master.wait_window()
    def doPass(self):
        pass
    def OK(self):
        for id in self.msubs.keys():
            self.msubs[id] = self.subprocess[id].get()
            if self.msubs[id] != 0:
                print id,self.msubs[id]
        self.master.destroy()
#######################################
if __name__=='__main__':
    root = Tk()
    pysubs = {}
    pysubs['msub'] = {}
    for i in range(1,400):
        pysubs['msub'][i] = 0

    PysubsMsubNonSM(root,pysubs['msub'])
    root.mainloop()
